using System;
using System.Collections.Generic;
using System.Text;
using System.Reflection;
using Microsoft.Xna.Framework;

namespace BasicEditor.Classes.Widgets
{
    public class ButtonTexturesWidget : Classes.GUIWidget
    {
        private Classes.GUIWidget leftWidget;
        private Classes.GUIWidget rightWidget;


        public Classes.GUIWidget LeftWidget
        {
            get { return leftWidget; }

            set
            {
                if (this.leftWidget != null) { this.leftWidget.Click -= new xFrippery.ClickEventHandler(LeftButton_Click); }
                leftWidget = value;
                if (this.leftWidget != null) { this.leftWidget.Click += new xFrippery.ClickEventHandler(LeftButton_Click); }
            }
        }

        public Classes.GUIWidget RightWidget
        {
            get { return rightWidget; }
            set
            {
                if (this.rightWidget != null) { this.rightWidget.Click -= new xFrippery.ClickEventHandler(RightButton_Click); }
                rightWidget = value;
                if (this.rightWidget != null) { this.rightWidget.Click += new xFrippery.ClickEventHandler(RightButton_Click); }
            }
        }

        public ButtonTexturesWidget()
            : base()
        {
            /*  
             // this.bounds = new Rectangle(0, 0, 100, 50);

             Assembly assembly = Assembly.GetExecutingAssembly();
             string file = "BasicEditor.Resources.ButtonTexturesWidget.xml";
             //xFrippery.GUIReader r = new xFrippery.GUIReader();
             //r.Load(assembly.GetManifestResourceStream(file));
             List<Classes.GUIWidget> items;
             items = xFrippery.GUIReader.Load<Classes.GUIWidget>(assembly.GetManifestResourceStream(file));

             // try to find a control with the name 'root' and set it's bounds to this widgets bounds
             // so it will be rendered acuractly and properly
             xFrippery.IControl mainctrl = this.Children.FindControl("root", false, true);
             if (mainctrl != null) { this.bounds = mainctrl.Bounds; }

             // add controls to widget
             foreach (xFrippery.IControl child in items)
             {
                 this.Children.Add(child);
                 child.Parent = this;
             }     

             // extract data stored in the control 'Data" property and set control properties from it
             this.ExtractData(true);  */
        }

        public override void Initilize()
        {
            // search for left and right texture button controls
            this.LeftWidget = this.children.FindControl<Classes.GUIWidget>("leftbutton", true, true);
            this.RightWidget = this.children.FindControl<Classes.GUIWidget>("rightbutton", true, true);

            // call base init 
            base.Initilize();
        }

        void RightButton_Click(object sender)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        void LeftButton_Click(object sender)
        {
            throw new Exception("The method or operation is not implemented.");
        }
    }
}
