//using CommonEventArgs;
using System;
using Microsoft;
//using System.Windows.Forms;
using System.Collections;
//using System.Drawing;
//using Microsoft.VisualBasic;
//using System.Windows;
//using System.Diagnostics;
//using System.Data;
using System.Collections.Generic;

//Created by: X
//Web: http://www.createdbyx.com/
//Date: Wednesday, February 22, 2006
//=============================================

namespace xFrippery
{
	public class KeyPressEventArgs 
	{
		
		
		public delegate void BeforeIDChangeEventHandler(object sender, StringChangeEventArgs e);
		private BeforeIDChangeEventHandler BeforeIDChangeEvent;
		
		public event BeforeIDChangeEventHandler BeforeIDChange
		{
			add
			{
				BeforeIDChangeEvent = (BeforeIDChangeEventHandler) System.Delegate.Combine(BeforeIDChangeEvent, value);
			}
			remove
			{
				BeforeIDChangeEvent = (BeforeIDChangeEventHandler) System.Delegate.Remove(BeforeIDChangeEvent, value);
			}
		}
		
		public delegate void AfterIDChangeEventHandler(object sender, StringEventArgs e);
		private AfterIDChangeEventHandler AfterIDChangeEvent;
		
		public event AfterIDChangeEventHandler AfterIDChange
		{
			add
			{
				AfterIDChangeEvent = (AfterIDChangeEventHandler) System.Delegate.Combine(AfterIDChangeEvent, value);
			}
			remove
			{
				AfterIDChangeEvent = (AfterIDChangeEventHandler) System.Delegate.Remove(AfterIDChangeEvent, value);
			}
		}
		
		
		protected internal string mstrID = string.Empty;
		
		public string ID
		{
			get
			{
				return mstrID;
			}
			set
			{
				// raise before event
				StringChangeEventArgs be = new StringChangeEventArgs(mstrID, value);
				try
				{
					if (BeforeIDChangeEvent != null)
						BeforeIDChangeEvent(this, be);
				}
				catch
				{
				}
				// check if wanting to cancel
				if (be.Cancel)
				{
					be = null;
					return;
				}
				// assign new value
				mstrID = be.NewValue;
				be = null;
				// raise after event
				try
				{
					if (AfterIDChangeEvent != null)
						AfterIDChangeEvent(this, new StringEventArgs(mstrID));
				}
				catch
				{
				}
			}
		}
		
		public KeyPressEventArgs(char keychar) : base(keychar)
		{
		}
		
		public KeyPressEventArgs(string ID, char keychar) : base(keychar)
		{
			this.mstrID = ID;
		}
	}
	
}
