//using CommonEventArgs;
using System;
using Microsoft;
//using System.Windows.Forms;
using System.Collections;
//using System.Drawing;
//using Microsoft.VisualBasic;
//using System.Windows;
//using System.Diagnostics;
//using System.Data;
using System.Collections.Generic;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace xFrippery
{
	public class InputHandler : IDisposable//, IControlEvents
	{
		
		
		
        //private ClickEventHandler ClickEvent;
		
        //public event ClickEventHandler Click
        //{
        //    add
        //    {
        //        ClickEvent = (ClickEventHandler) System.Delegate.Combine(ClickEvent, value);
        //    }
        //    remove
        //    {
        //        ClickEvent = (ClickEventHandler) System.Delegate.Remove(ClickEvent, value);
        //    }
        //}
		
        //private KeyDownEventHandler KeyDownEvent;
		
        //public event KeyDownEventHandler KeyDown
        //{
        //    add
        //    {
        //        KeyDownEvent = (KeyDownEventHandler) System.Delegate.Combine(KeyDownEvent, value);
        //    }
        //    remove
        //    {
        //        KeyDownEvent = (KeyDownEventHandler) System.Delegate.Remove(KeyDownEvent, value);
        //    }
        //}
		
        //private KeyPressedEventHandler KeyPressedEvent;
		
        //public event KeyPressedEventHandler KeyPressed
        //{
        //    add
        //    {
        //        KeyPressedEvent = (KeyPressedEventHandler) System.Delegate.Combine(KeyPressedEvent, value);
        //    }
        //    remove
        //    {
        //        KeyPressedEvent = (KeyPressedEventHandler) System.Delegate.Remove(KeyPressedEvent, value);
        //    }
        //}
		
        //private KeyUpEventHandler KeyUpEvent;
		
        //public event KeyUpEventHandler KeyUp
        //{
        //    add
        //    {
        //        KeyUpEvent = (KeyUpEventHandler) System.Delegate.Combine(KeyUpEvent, value);
        //    }
        //    remove
        //    {
        //        KeyUpEvent = (KeyUpEventHandler) System.Delegate.Remove(KeyUpEvent, value);
        //    }
        //}
		
        //private MouseDownEventHandler MouseDownEvent;
		
        //public event MouseDownEventHandler MouseDown
        //{
        //    add
        //    {
        //        MouseDownEvent = (MouseDownEventHandler) System.Delegate.Combine(MouseDownEvent, value);
        //    }
        //    remove
        //    {
        //        MouseDownEvent = (MouseDownEventHandler) System.Delegate.Remove(MouseDownEvent, value);
        //    }
        //}
		
        //private MouseMoveEventHandler MouseMoveEvent;
		
        //public event MouseMoveEventHandler MouseMove
        //{
        //    add
        //    {
        //        MouseMoveEvent = (MouseMoveEventHandler) System.Delegate.Combine(MouseMoveEvent, value);
        //    }
        //    remove
        //    {
        //        MouseMoveEvent = (MouseMoveEventHandler) System.Delegate.Remove(MouseMoveEvent, value);
        //    }
        //}
		
        //private MouseUpEventHandler MouseUpEvent;
		
        //public event MouseUpEventHandler MouseUp
        //{
        //    add
        //    {
        //        MouseUpEvent = (MouseUpEventHandler) System.Delegate.Combine(MouseUpEvent, value);
        //    }
        //    remove
        //    {
        //        MouseUpEvent = (MouseUpEventHandler) System.Delegate.Remove(MouseUpEvent, value);
        //    }
        //}
		
		
		
		protected internal ControlCollection mobjControls = new ControlCollection();
		private MouseButtons mobjMouseButtonDown = MouseButtons.None;
		private string mobjMouseButtonDownOnControlID = string.Empty;
		
		
		public ControlCollection Controls
		{
			get
			{
				return mobjControls;
			}
			set
			{
				mobjControls = value;
			}
		}

        public void DoMouseDown(object sender, MouseButtons b, Vector2 pos)
		{
			if (mobjControls == null)
			{
				return;
			}
			foreach (Control c in mobjControls)
			{
				Control Tmp;
				Tmp = c.GetControlFromPoint(e.X, e.Y);
				if ((Tmp != null)&& Tmp.Visible && Tmp.Name != string.Empty)
				{
					try
					{
                        Vector2 Pt = Tmp.PointToClient(new Vector2(pos.X, pos.Y));
						mobjMouseButtonDown = e.Button;
						mobjMouseButtonDownOnControlID = Tmp.Name;
						if (MouseDownEvent != null)
							MouseDownEvent(sender, new MouseEventArgs(Tmp, e.Button, e.Clicks, System.Convert.ToInt32(Pt.X), System.Convert.ToInt32(Pt.Y), e.Delta));
					}
					catch
					{
					}
					
					goto endOfForLoop;
				}
			}
endOfForLoop:
			1.GetHashCode() ; //nop
		}

        public void DoMouseMove(object sender, MouseButtons b, Vector2 pos)
		{
			if (mobjControls == null)
			{
				return;
			}
			foreach (Control c in mobjControls)
			{
				Control Tmp;
				Tmp = c.GetControlFromPoint(e.X, e.Y);
				if ((Tmp != null)&& Tmp.Visible && Tmp.Name != string.Empty)
				{
					try
					{
						PointF Pt = Tmp.PointToClient(new PointF(e.X, e.Y));
						if (MouseMoveEvent != null)
							MouseMoveEvent(sender, new MouseEventArgs(Tmp, e.Button, e.Clicks, System.Convert.ToInt32(Pt.X), System.Convert.ToInt32(Pt.Y), e.Delta));
					}
					catch
					{
					}
					
					goto endOfForLoop;
				}
			}
endOfForLoop:
			1.GetHashCode() ; //nop
		}

        public void DoMouseUp(object sender, MouseButtons b, Vector2 pos)
		{
			if (mobjControls == null)
			{
				return;
			}
			foreach (Control c in mobjControls)
			{
				Control Tmp;
				Tmp = c.GetControlFromPoint(e.X, e.Y);
				if ((Tmp != null)&& Tmp.Visible && Tmp.Name != string.Empty)
				{
					PointF Pt = Tmp.PointToClient(new PointF(e.X, e.Y));
					MouseEventArgs Args = new MouseEventArgs(Tmp, e.Button, e.Clicks, System.Convert.ToInt32(Pt.X), System.Convert.ToInt32(Pt.Y), e.Delta);
					try
					{
						if (MouseUpEvent != null)
							MouseUpEvent(sender, Args);
					}
					catch
					{
					}
					
					// check if same control and button that clicked down on the control
					if (mobjMouseButtonDown == e.Button)
					{
						if (mobjMouseButtonDownOnControlID == Tmp.Name)
						{
							try
							{
								if (ClickEvent != null)
									ClickEvent(sender, Args);
							}
							catch (Exception)
							{
							}
						}
					}
					goto endOfForLoop;
				}
			}
endOfForLoop:
			1.GetHashCode() ; //nop
		}
		
		public void DoKeyDown(object sender, Keys e)
		{
			try
			{
				if (KeyDownEvent != null)
                    KeyDownEvent(sender, new Keys(e.KeyCode));
			}
			catch
			{
			}
		}

        public void DoKeyPressed(object sender, Keys e)
		{
			try
			{
				if (KeyPressedEvent != null)
					KeyPressedEvent(sender, new KeyPressEventArgs(e.KeyChar));
			}
			catch
			{
			}
		}

        public void DoKeyUp(object sender, Keys e)
		{
			try
			{
				if (KeyUpEvent != null)
					KeyUpEvent(sender, new KeyEventArgs(e.KeyCode));
			}
			catch
			{
			}
		}
		
		#region " IDisposable Support "
		private bool disposedValue = false; // To detect redundant calls
		
		// IDisposable
		protected virtual void Dispose(bool disposing)
		{
			if (! this.disposedValue)
			{
				if (disposing)
				{
					// TODO: free unmanaged resources when explicitly called
					mobjControls = null;
				}
				
				// TODO: free shared unmanaged resources
			}
			this.disposedValue = true;
		}
		
		// This code added by Visual Basic to correctly implement the disposable pattern.
		public void Dispose()
		{
			// Do not change this code.  Put cleanup code in Dispose(ByVal disposing As Boolean) above.
			Dispose(true);
			GC.SuppressFinalize(this);
		}
		#endregion
		
		public InputHandler()
		{
			
		}
		
		public InputHandler(ControlCollection Controls)
		{
			mobjControls = Controls;
		}
	}
	
}
