using System;
using System.Collections.Generic;
using System.Text;
                using Microsoft.Xna.Framework;
                using Microsoft.Xna.Framework.Graphics;

namespace BasicEditor
{
    public abstract class Block
    {
        internal protected Texture2D tex;
        internal protected Rectangle sourceRect;
        internal protected Color color = Color.White;


        public Color Color
        {
            get { return color; }
            set { color = value; }
        }       	

        public Rectangle SourceRectangle
        {
            get { return sourceRect; }
            set { sourceRect = value; }
        }

        public int SourceLeft
        {
            get { return sourceRect.X; }
            set { sourceRect.X = value; }
        }

        public int SourceTop
        {
            get { return sourceRect.Y; }
            set { sourceRect.Y = value; }
        }

        public int SourceWidth
        {
            get { return sourceRect.Width; }
            set { sourceRect.Width = value; }
        }

        public int SourceHeight
        {
            get { return sourceRect.Height; }
            set { sourceRect.Height = value; }
        }

        public Texture2D Texture
        {
            get { return tex; }
            set { tex = value; }
        }
    }
}
