
#region Using Statements
using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
#endregion

namespace BasicEditor.Components
{
    /// <summary>
    /// This is a game component that implements IUpdateable.
    /// </summary>
    public partial class TextureSelector : Microsoft.Xna.Framework.DrawableGameComponent
    {
        public delegate void SelectedTextureEventHandler(string Name, Rectangle sourceRectangle);

        private Collections.TextureDictionary textures;

        public event SelectedTextureEventHandler SelectedTexture
        {
            add { this.SelectedTexture += value; }
            remove { this.SelectedTexture -= value; }
        }

        public Collections.TextureDictionary Textures
        {
            get { return textures; }
            set { textures = value; }
        }

        public TextureSelector(Game game)
            : base(game)
        {
            // TODO: Construct any child components here
        }

        /// <summary>
        /// Allows the game component to perform any initialization it needs to before starting
        /// to run.  This is where it can query for any required services and load content.
        /// </summary>
        public override void Initialize()
        {
            // TODO: Add your initialization code here

            base.Initialize();
        }


        /// <summary>
        /// Allows the game component to update itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        public override void Update(GameTime gameTime)
        {
            // TODO: Add your update code here

            base.Update(gameTime);
        }

        /// <summary>
        /// Allows the game component to draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        public override void Draw(GameTime gameTime)
        {
            // TODO: Add your draw code here

            base.Draw(gameTime);
        }
    }
}


