using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace BasicEditor.Interfaces
{
    public interface IGUIWidget
    {
        Color Color {get; set; }
        Rectangle SourceRectangle {get; set; }
        Texture2D Texture {get; set; }
        string TextureName {get; set; } 
        void Update(Editor game, GameTime gameTime);
        void Draw(GameTime gameTime, SpriteBatch sb);
       // void Draw(Interfaces.IGUIWidget c, GameTime gameTime, SpriteBatch sb);
    }
}
